<template>
  <div style="border: 1px solid #ccc">
    <Toolbar style="border-bottom: 1px solid #ccc" :editor="editorRef" :defaultConfig="toolbarConfig" :mode="mode" />
    <Editor style="height: 400px; overflow-y: hidden;" v-model="valueHtml" :defaultConfig="editorConfig" :mode="mode"
      @onCreated="handleCreated" @onChange="handleChange" />
  </div>
</template>

<script setup lang="ts">
import '@wangeditor/editor/dist/css/style.css' // 引入 css

import { onBeforeUnmount, shallowRef, computed } from 'vue'
import { Editor, Toolbar } from '@wangeditor/editor-for-vue'
import { createStorage } from "@/services/api/storage";

type InsertFnType = (url: string, alt?: string, href?: string) => void

type InsertFnTypeVideo = (url: string, poster?: string) => void


const props = defineProps({
  valueHtml: {
    type: String,
    default: ''
  }
})

const valueHtml = computed({
  get: () => props.valueHtml,
  set: (value) => emits("htmlChange", value),
})

const mode = shallowRef('mode')
const emits = defineEmits(['htmlChange'])

// 编辑器实例，必须用 shallowRef
const editorRef = shallowRef()

const toolbarConfig = {}
const editorConfig: any = { placeholder: '请输入内容...', MENU_CONF: {} }

// 自定义上传图片
editorConfig.MENU_CONF['uploadImage'] = {
  customUpload(file: File, insertFn: InsertFnTypeVideo) {
    console.log(file);
    const formData = new FormData()
    formData.append('file', file)
    createStorage(formData).then((res: any) => {
      if (res.code === 200) {
        insertFn(res.data.url)
      }
    })
  },
}

// // 插入图片
// editorConfig.MENU_CONF['insertImage'] = {
//     onInsertedImage(imageNode: ImageElement | null) {  // TS 语法
//         if (imageNode == null) return

//         const { src, alt, url, href } = imageNode
//         console.log('inserted image', src, alt, url, href)
//     },
//     checkImage: customCheckImageFn, // 也支持 async 函数
//     parseImageSrc: customParseImageSrc, // 也支持 async 函数
// }

// 自定义上传视频
editorConfig.MENU_CONF['uploadVideo'] = {
  customUpload(file: File, insertFn: InsertFnType) {
    console.log(file);
    const formData = new FormData()
    formData.append('file', file)
    createStorage(formData).then((res: any) => {
      if (res.code === 200) {
        insertFn(res.data.url)
      }
    })
  },
}


// 组件销毁时，也及时销毁编辑器
onBeforeUnmount(() => {
  const editor = editorRef.value
  if (editor == null) return
  editor.destroy()
})

const handleCreated = (editor: any) => {
  editorRef.value = editor // 记录 editor 实例，重要！
}

const handleChange = (editor: any) => {
  const html = editor.getHtml()
  emits('htmlChange', html)
}

</script>    